import * as Gametest from "@minecraft/server-gametest";
import { system, world, ItemTypes, ItemStack, Player, EntityHurtAfterEvent, EntityHitBlockAfterEvent,ItemStartUseOnAfterEvent, ItemUseAfterEvent, Container } from '@minecraft/server';

var state = "desactive";

world.afterEvents.entityHurt.subscribe((event) => {
    try{
    const player = event.damageSource.damagingEntity;
    if (!(player instanceof Player)) return;
    const mob = event.hurtEntity;
    const container = player.getComponent("inventory").container;
    const item = container.getItem(player.selectedSlot);
    if (item == null) return;
    const lore = item.getLore();
    if ((item.typeId == "sw:net" || item.typeId == "sw:golden_net" || item.typeId == "sw:diamond_net") && item.getLore()[0] == null && mob.typeId != "minecraft:player") {
        const dropItem = new ItemStack('minecraft:snowball', 1);
        let id = "ID: " + generarID();
        let mobName = mob.typeId;
        const overworld = world.getDimension('overworld');
        if (mob.nameTag == "") {
            item.setLore([id, "§fMob: " + mobName]);
        } else {
            item.setLore([id, "§fMob: " + mobName, "§fNameTag: " + mob.nameTag]);
        }
        mob.addTag(id);
        mob.addTag("tpgu");
        mob.runCommandAsync(`tellraw @p {"rawtext":[{"translate":"text.caught"},{"text":"§b"},{"selector":"@s"},{"text":"§f!"}]}`);
        mob.runCommandAsync(`particle minecraft:death_explosion_emitter ~~~`);
        container.setItem(player.selectedSlot, item);
        /*overworld.spawnItem(dropItem, mob.location);*/
        mob.runCommandAsync(`playsound mob.shulker.close @a[r=8] ~~~ 0.7`);
        mob.teleport(player.location);
    }
    else if (item.typeId == "sw:pokeball" && item.getLore()[0] == null && mob.typeId != "minecraft:player") {
        const dropItem = new ItemStack('sw:pokeball', 1);
        let id = "ID: " + generarID();
        let mobName = mob.typeId;
        if (mob.nameTag == "") {
            dropItem.setLore([id, "§fMob: " + mobName]);
        } else {
            dropItem.setLore([id, "§fMob: " + mobName, "§fNameTag: " + mob.nameTag]);
        }
        mob.addTag(id);
        mob.addTag("tpgu");
        mob.runCommandAsync(`tellraw @p {"rawtext":[{"translate":"text.caught"},{"text":"§b"},{"selector":"@s"},{"text":"§f!"}]}`);
        mob.runCommandAsync(`particle minecraft:death_explosion_emitter ~~~`);
        const dimension = player.dimension.id;
        const overworld = world.getDimension(dimension);
        overworld.spawnItem(dropItem, mob.location);
        player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 air`);
        player.runCommandAsync(`playsound pokeball.catch @a[r=8] ~~~ 0.7`);
        mob.teleport(player.location);
    } else if (item.typeId == "sw:mobcatcher" && item.getLore()[0] == null && mob.typeId != "minecraft:player") {
        const dropItem = new ItemStack('sw:mobdropper', 1);
        let id = "ID: " + generarID();
        let mobName = mob.typeId;
        if (mob.nameTag == "") {
            dropItem.setLore([id, "§fMob: " + mobName]);
        } else {
            dropItem.setLore([id, "§fMob: " + mobName, "§fNameTag: " + mob.nameTag]);
        }
        mob.addTag(id);
        mob.addTag("tpgu");
        mob.runCommandAsync(`tellraw @p {"rawtext":[{"translate":"text.caught"},{"text":"§b"},{"selector":"@s"},{"text":"§f!"}]}`);
        mob.runCommandAsync(`particle minecraft:death_explosion_emitter ~~~`);
        const dimension = player.dimension.id;
        const overworld = world.getDimension(dimension);
        overworld.spawnItem(dropItem, mob.location);
        player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 air`);
        player.runCommandAsync(`playsound pokeball.catch @a[r=8] ~~~ 0.7`);
        mob.teleport(player.location);
    } else if (item.typeId == "sw:iman" && item.getLore()[0] == null && mob.typeId != "minecraft:player") {
        mob.addTag("iman");
        mob.teleport(player.location);
    }
    }
    catch(e){
    }
})

function generarID() {
    let letter = ["A", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"];
    return letter[Math.floor(Math.random() * 23)] + letter[Math.floor(Math.random() * 23)] + letter[Math.floor(Math.random() * 23)] + Math.floor(Math.random() * 10000);
}
function itemDetect() {
    world.afterEvents.itemStartUseOn.subscribe((event) => {
        let player = event.source;
        let block = event.block;
        if (!(player instanceof Player)) return;
        const container = player.getComponent("inventory").container;
        let item = container.getItem(player.selectedSlot);
        if (item == null) return;
        let itemId = item.typeId;
        if (itemId == null) return;
        if (block == null) return;
        if (!(player instanceof Player)) return;
        if ((itemId == "sw:net" || itemId == "sw:golden_net" || itemId == "sw:diamond_net") && block.typeId != "minecraft:air") {
            if (item.getLore()[0] == null) return;
            let lore = item.getLore()[0];
            let entities = entitiesGet(lore);
            if (entities == null) return;
            for (let entity of entities) {
                let entityTags = entity.getTags();
                for (let entityTag of entityTags) {
                    if (entityTag == lore) {
                        entity.removeTag("tpgu");
                        entity.removeTag(lore);
                        item.setLore(null);
                        entity.addTag("teleport");
                        container.setItem(player.selectedSlot, item);
                        const dimension = player.dimension.id;
                        const locatblock = { x: block.location.x, y: block.location.y + 1, z: block.location.z };
                        const teleport = world.getDimension(dimension).spawnEntity("sw:ctp", locatblock);
                        entity.runCommandAsync(`tp @s @e[type=sw:ctp,c=1]`);
                        player.runCommandAsync(`playsound mob.shulker.close @a[r=8] ~~~ 0.7`);
                        teleport.runCommandAsync(`event entity @s minecraft:despawn`);
                        entity.removeTag("teleport");
                        break;
                    }
                }
            }
        } else if (itemId == "sw:pokeball" && block.typeId != "minecraft:air") {
            if (item.getLore()[0] == null) return;
            let lore = item.getLore()[0];
            let entities = entitiesGet(lore);
            if (entities == null) return;
            for (let entity of entities) {
                let entityTags = entity.getTags();
                for (let entityTag of entityTags) {
                    if (entityTag == lore) {
                        entity.removeTag("tpgu");
                        entity.removeTag(lore);
                        entity.addTag("teleport");
                        container.setItem(player.selectedSlot, item);
                        const dimension = player.dimension.id;
                        const locatblock = { x: block.location.x, y: block.location.y + 1, z: block.location.z };
                        const teleport = world.getDimension(dimension).spawnEntity("sw:ctp", locatblock);
                        entity.runCommandAsync(`tp @s @e[type=sw:ctp,c=1]`);
                        const dropItem = new ItemStack('sw:pokeball', 1);
                        world.getDimension(dimension).spawnItem(dropItem, teleport.location);
                        player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 air`);
                        player.runCommandAsync(`playsound pokeball.solt @a[r=8] ~~~ 0.7`);
                        teleport.runCommandAsync(`event entity @s minecraft:despawn`);
                        entity.removeTag("teleport");
                        break;
                    }
                }
            }
        }else if (itemId == "sw:mobdropper" && block.typeId != "minecraft:air") {
            if (item.getLore()[0] == null) return;
            let lore = item.getLore()[0];
            let entities = entitiesGet(lore);
            if (entities == null) return;
            for (let entity of entities) {
                let entityTags = entity.getTags();
                for (let entityTag of entityTags) {
                    if (entityTag == lore) {
                        entity.removeTag("tpgu");
                        entity.removeTag(lore);
                        entity.addTag("teleport");
                        container.setItem(player.selectedSlot, item);
                        const dimension = player.dimension.id;
                        const locatblock = { x: block.location.x, y: block.location.y + 1, z: block.location.z };
                        const teleport = world.getDimension(dimension).spawnEntity("sw:ctp", locatblock);
                        entity.runCommandAsync(`tp @s @e[type=sw:ctp,c=1]`);
                        const dropItem = new ItemStack('sw:mobcatcher', 1);
                        world.getDimension(dimension).spawnItem(dropItem, teleport.location);
                        player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 air`);
                        player.runCommandAsync(`playsound pokeball.solt @a[r=8] ~~~ 0.7`);
                        teleport.runCommandAsync(`event entity @s minecraft:despawn`);
                        entity.removeTag("teleport");
                        break;
                    }
                }
            }
        }
    })
}

function entitiesGet(id) {
    let tag = { tags: ["tpgu"] }
    let entities = world.getDimension(`overworld`).getEntities(tag);
    return entities;
}

system.runInterval(() => {
    try{
    itemDetect();
    }
    catch(e){}
}, 1)

system.runTimeout(() => {
    let tag = { tags: ["central"] }
    let entities = world.getDimension(`overworld`).getEntities(tag);
    if( entities.length  < 1){
    world.sendMessage("Mob Catchers loaded successfully!");
    const spawn = { x: world.getDefaultSpawnLocation().x, y: -62, z: world.getDefaultSpawnLocation().z };
    world.getDimension(`overworld`).spawnEntity("sw:central2", spawn);
    }
}, 100)




Gametest.register("Test", "player", (test) => {
    const playerName = `NetSystem`;
    const player = test.spawnSimulatedPlayer({ x: 1, y: 2, z: 1 }, playerName);
    player.runCommandAsync('tp @s @e[name=central, c=1]');
    player.runCommandAsync('gamerule dodaylightcycle true');
    player.runCommandAsync('gamerule domobspawning true');
    player.runCommandAsync('gamerule randomtickspeed 1');
    player.runCommandAsync('gamerule doweathercycle true');
}).structureName("ComponentTests:netsystem")
    .maxTicks(2147483647)
    .tag(Gametest.Tags.suiteDefault);



